<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAlarmMessageResult_v2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfAlarmMessageResult_v2 extends AbstractStructArrayBase
{
    /**
     * The AlarmMessageResult_v2
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AlarmMessageResult_v2[]
     */
    public $AlarmMessageResult_v2;
    /**
     * Constructor method for ArrayOfAlarmMessageResult_v2
     * @uses ArrayOfAlarmMessageResult_v2::setAlarmMessageResult_v2()
     * @param \StructType\AlarmMessageResult_v2[] $alarmMessageResult_v2
     */
    public function __construct(array $alarmMessageResult_v2 = array())
    {
        $this
            ->setAlarmMessageResult_v2($alarmMessageResult_v2);
    }
    /**
     * Get AlarmMessageResult_v2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AlarmMessageResult_v2[]|null
     */
    public function getAlarmMessageResult_v2()
    {
        return isset($this->AlarmMessageResult_v2) ? $this->AlarmMessageResult_v2 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAlarmMessageResult_v2 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAlarmMessageResult_v2 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAlarmMessageResult_v2ForArrayConstraintsFromSetAlarmMessageResult_v2(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAlarmMessageResult_v2AlarmMessageResult_v2Item) {
            // validation for constraint: itemType
            if (!$arrayOfAlarmMessageResult_v2AlarmMessageResult_v2Item instanceof \StructType\AlarmMessageResult_v2) {
                $invalidValues[] = is_object($arrayOfAlarmMessageResult_v2AlarmMessageResult_v2Item) ? get_class($arrayOfAlarmMessageResult_v2AlarmMessageResult_v2Item) : sprintf('%s(%s)', gettype($arrayOfAlarmMessageResult_v2AlarmMessageResult_v2Item), var_export($arrayOfAlarmMessageResult_v2AlarmMessageResult_v2Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AlarmMessageResult_v2 property can only contain items of type \StructType\AlarmMessageResult_v2, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AlarmMessageResult_v2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AlarmMessageResult_v2[] $alarmMessageResult_v2
     * @return \ArrayType\ArrayOfAlarmMessageResult_v2
     */
    public function setAlarmMessageResult_v2(array $alarmMessageResult_v2 = array())
    {
        // validation for constraint: array
        if ('' !== ($alarmMessageResult_v2ArrayErrorMessage = self::validateAlarmMessageResult_v2ForArrayConstraintsFromSetAlarmMessageResult_v2($alarmMessageResult_v2))) {
            throw new \InvalidArgumentException($alarmMessageResult_v2ArrayErrorMessage, __LINE__);
        }
        if (is_null($alarmMessageResult_v2) || (is_array($alarmMessageResult_v2) && empty($alarmMessageResult_v2))) {
            unset($this->AlarmMessageResult_v2);
        } else {
            $this->AlarmMessageResult_v2 = $alarmMessageResult_v2;
        }
        return $this;
    }
    /**
     * Add item to AlarmMessageResult_v2 value
     * @throws \InvalidArgumentException
     * @param \StructType\AlarmMessageResult_v2 $item
     * @return \ArrayType\ArrayOfAlarmMessageResult_v2
     */
    public function addToAlarmMessageResult_v2(\StructType\AlarmMessageResult_v2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AlarmMessageResult_v2) {
            throw new \InvalidArgumentException(sprintf('The AlarmMessageResult_v2 property can only contain items of type \StructType\AlarmMessageResult_v2, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AlarmMessageResult_v2[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AlarmMessageResult_v2|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AlarmMessageResult_v2|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AlarmMessageResult_v2|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AlarmMessageResult_v2|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AlarmMessageResult_v2|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AlarmMessageResult_v2
     */
    public function getAttributeName()
    {
        return 'AlarmMessageResult_v2';
    }
}
